package com.chinaitop.depot;

import org.mybatis.spring.annotation.MapperScan;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.cloud.client.discovery.EnableDiscoveryClient;
import org.springframework.cloud.netflix.eureka.EnableEurekaClient;

@EnableEurekaClient
@EnableDiscoveryClient
@SpringBootApplication
@MapperScan(basePackages = {"com.chinaitop.depot.*.mapper"})
public class DepotDeviceApplication {

	public static void main(String[] args) {
		SpringApplication.run(DepotDeviceApplication.class, args);
	}
}
