package com.chinaitop.depot.device.model;

import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

public class StorageDevicebackExample {
    /**
     * storage_deviceback
     */
    protected String orderByClause;

    /**
     * storage_deviceback
     */
    protected boolean distinct;

    /**
     * storage_deviceback
     */
    protected List<Criteria> oredCriteria;

    public StorageDevicebackExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    /**
     * storage_deviceback 2018-03-22
     */
    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        protected void addCriterionForJDBCDate(String condition, Date value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value.getTime()), property);
        }

        protected void addCriterionForJDBCDate(String condition, List<Date> values, String property) {
            if (values == null || values.size() == 0) {
                throw new RuntimeException("Value list for " + property + " cannot be null or empty");
            }
            List<java.sql.Date> dateList = new ArrayList<java.sql.Date>();
            Iterator<Date> iter = values.iterator();
            while (iter.hasNext()) {
                dateList.add(new java.sql.Date(iter.next().getTime()));
            }
            addCriterion(condition, dateList, property);
        }

        protected void addCriterionForJDBCDate(String condition, Date value1, Date value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value1.getTime()), new java.sql.Date(value2.getTime()), property);
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Integer value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Integer value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Integer value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Integer value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Integer value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Integer> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Integer> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Integer value1, Integer value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Integer value1, Integer value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andGetIdIsNull() {
            addCriterion("get_id is null");
            return (Criteria) this;
        }

        public Criteria andGetIdIsNotNull() {
            addCriterion("get_id is not null");
            return (Criteria) this;
        }

        public Criteria andGetIdEqualTo(Integer value) {
            addCriterion("get_id =", value, "getId");
            return (Criteria) this;
        }

        public Criteria andGetIdNotEqualTo(Integer value) {
            addCriterion("get_id <>", value, "getId");
            return (Criteria) this;
        }

        public Criteria andGetIdGreaterThan(Integer value) {
            addCriterion("get_id >", value, "getId");
            return (Criteria) this;
        }

        public Criteria andGetIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("get_id >=", value, "getId");
            return (Criteria) this;
        }

        public Criteria andGetIdLessThan(Integer value) {
            addCriterion("get_id <", value, "getId");
            return (Criteria) this;
        }

        public Criteria andGetIdLessThanOrEqualTo(Integer value) {
            addCriterion("get_id <=", value, "getId");
            return (Criteria) this;
        }

        public Criteria andGetIdIn(List<Integer> values) {
            addCriterion("get_id in", values, "getId");
            return (Criteria) this;
        }

        public Criteria andGetIdNotIn(List<Integer> values) {
            addCriterion("get_id not in", values, "getId");
            return (Criteria) this;
        }

        public Criteria andGetIdBetween(Integer value1, Integer value2) {
            addCriterion("get_id between", value1, value2, "getId");
            return (Criteria) this;
        }

        public Criteria andGetIdNotBetween(Integer value1, Integer value2) {
            addCriterion("get_id not between", value1, value2, "getId");
            return (Criteria) this;
        }

        public Criteria andBackKeeperIsNull() {
            addCriterion("back_keeper is null");
            return (Criteria) this;
        }

        public Criteria andBackKeeperIsNotNull() {
            addCriterion("back_keeper is not null");
            return (Criteria) this;
        }

        public Criteria andBackKeeperEqualTo(String value) {
            addCriterion("back_keeper =", value, "backKeeper");
            return (Criteria) this;
        }

        public Criteria andBackKeeperNotEqualTo(String value) {
            addCriterion("back_keeper <>", value, "backKeeper");
            return (Criteria) this;
        }

        public Criteria andBackKeeperGreaterThan(String value) {
            addCriterion("back_keeper >", value, "backKeeper");
            return (Criteria) this;
        }

        public Criteria andBackKeeperGreaterThanOrEqualTo(String value) {
            addCriterion("back_keeper >=", value, "backKeeper");
            return (Criteria) this;
        }

        public Criteria andBackKeeperLessThan(String value) {
            addCriterion("back_keeper <", value, "backKeeper");
            return (Criteria) this;
        }

        public Criteria andBackKeeperLessThanOrEqualTo(String value) {
            addCriterion("back_keeper <=", value, "backKeeper");
            return (Criteria) this;
        }

        public Criteria andBackKeeperLike(String value) {
            addCriterion("back_keeper like", value, "backKeeper");
            return (Criteria) this;
        }

        public Criteria andBackKeeperNotLike(String value) {
            addCriterion("back_keeper not like", value, "backKeeper");
            return (Criteria) this;
        }

        public Criteria andBackKeeperIn(List<String> values) {
            addCriterion("back_keeper in", values, "backKeeper");
            return (Criteria) this;
        }

        public Criteria andBackKeeperNotIn(List<String> values) {
            addCriterion("back_keeper not in", values, "backKeeper");
            return (Criteria) this;
        }

        public Criteria andBackKeeperBetween(String value1, String value2) {
            addCriterion("back_keeper between", value1, value2, "backKeeper");
            return (Criteria) this;
        }

        public Criteria andBackKeeperNotBetween(String value1, String value2) {
            addCriterion("back_keeper not between", value1, value2, "backKeeper");
            return (Criteria) this;
        }

        public Criteria andBackHandlerIsNull() {
            addCriterion("back_handler is null");
            return (Criteria) this;
        }

        public Criteria andBackHandlerIsNotNull() {
            addCriterion("back_handler is not null");
            return (Criteria) this;
        }

        public Criteria andBackHandlerEqualTo(String value) {
            addCriterion("back_handler =", value, "backHandler");
            return (Criteria) this;
        }

        public Criteria andBackHandlerNotEqualTo(String value) {
            addCriterion("back_handler <>", value, "backHandler");
            return (Criteria) this;
        }

        public Criteria andBackHandlerGreaterThan(String value) {
            addCriterion("back_handler >", value, "backHandler");
            return (Criteria) this;
        }

        public Criteria andBackHandlerGreaterThanOrEqualTo(String value) {
            addCriterion("back_handler >=", value, "backHandler");
            return (Criteria) this;
        }

        public Criteria andBackHandlerLessThan(String value) {
            addCriterion("back_handler <", value, "backHandler");
            return (Criteria) this;
        }

        public Criteria andBackHandlerLessThanOrEqualTo(String value) {
            addCriterion("back_handler <=", value, "backHandler");
            return (Criteria) this;
        }

        public Criteria andBackHandlerLike(String value) {
            addCriterion("back_handler like", value, "backHandler");
            return (Criteria) this;
        }

        public Criteria andBackHandlerNotLike(String value) {
            addCriterion("back_handler not like", value, "backHandler");
            return (Criteria) this;
        }

        public Criteria andBackHandlerIn(List<String> values) {
            addCriterion("back_handler in", values, "backHandler");
            return (Criteria) this;
        }

        public Criteria andBackHandlerNotIn(List<String> values) {
            addCriterion("back_handler not in", values, "backHandler");
            return (Criteria) this;
        }

        public Criteria andBackHandlerBetween(String value1, String value2) {
            addCriterion("back_handler between", value1, value2, "backHandler");
            return (Criteria) this;
        }

        public Criteria andBackHandlerNotBetween(String value1, String value2) {
            addCriterion("back_handler not between", value1, value2, "backHandler");
            return (Criteria) this;
        }

        public Criteria andCollatorIsNull() {
            addCriterion("collator is null");
            return (Criteria) this;
        }

        public Criteria andCollatorIsNotNull() {
            addCriterion("collator is not null");
            return (Criteria) this;
        }

        public Criteria andCollatorEqualTo(String value) {
            addCriterion("collator =", value, "collator");
            return (Criteria) this;
        }

        public Criteria andCollatorNotEqualTo(String value) {
            addCriterion("collator <>", value, "collator");
            return (Criteria) this;
        }

        public Criteria andCollatorGreaterThan(String value) {
            addCriterion("collator >", value, "collator");
            return (Criteria) this;
        }

        public Criteria andCollatorGreaterThanOrEqualTo(String value) {
            addCriterion("collator >=", value, "collator");
            return (Criteria) this;
        }

        public Criteria andCollatorLessThan(String value) {
            addCriterion("collator <", value, "collator");
            return (Criteria) this;
        }

        public Criteria andCollatorLessThanOrEqualTo(String value) {
            addCriterion("collator <=", value, "collator");
            return (Criteria) this;
        }

        public Criteria andCollatorLike(String value) {
            addCriterion("collator like", value, "collator");
            return (Criteria) this;
        }

        public Criteria andCollatorNotLike(String value) {
            addCriterion("collator not like", value, "collator");
            return (Criteria) this;
        }

        public Criteria andCollatorIn(List<String> values) {
            addCriterion("collator in", values, "collator");
            return (Criteria) this;
        }

        public Criteria andCollatorNotIn(List<String> values) {
            addCriterion("collator not in", values, "collator");
            return (Criteria) this;
        }

        public Criteria andCollatorBetween(String value1, String value2) {
            addCriterion("collator between", value1, value2, "collator");
            return (Criteria) this;
        }

        public Criteria andCollatorNotBetween(String value1, String value2) {
            addCriterion("collator not between", value1, value2, "collator");
            return (Criteria) this;
        }

        public Criteria andBackTimeIsNull() {
            addCriterion("back_time is null");
            return (Criteria) this;
        }

        public Criteria andBackTimeIsNotNull() {
            addCriterion("back_time is not null");
            return (Criteria) this;
        }

        public Criteria andBackTimeEqualTo(Date value) {
            addCriterionForJDBCDate("back_time =", value, "backTime");
            return (Criteria) this;
        }

        public Criteria andBackTimeNotEqualTo(Date value) {
            addCriterionForJDBCDate("back_time <>", value, "backTime");
            return (Criteria) this;
        }

        public Criteria andBackTimeGreaterThan(Date value) {
            addCriterionForJDBCDate("back_time >", value, "backTime");
            return (Criteria) this;
        }

        public Criteria andBackTimeGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("back_time >=", value, "backTime");
            return (Criteria) this;
        }

        public Criteria andBackTimeLessThan(Date value) {
            addCriterionForJDBCDate("back_time <", value, "backTime");
            return (Criteria) this;
        }

        public Criteria andBackTimeLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("back_time <=", value, "backTime");
            return (Criteria) this;
        }

        public Criteria andBackTimeIn(List<Date> values) {
            addCriterionForJDBCDate("back_time in", values, "backTime");
            return (Criteria) this;
        }

        public Criteria andBackTimeNotIn(List<Date> values) {
            addCriterionForJDBCDate("back_time not in", values, "backTime");
            return (Criteria) this;
        }

        public Criteria andBackTimeBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("back_time between", value1, value2, "backTime");
            return (Criteria) this;
        }

        public Criteria andBackTimeNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("back_time not between", value1, value2, "backTime");
            return (Criteria) this;
        }

        public Criteria andBrokenCountIsNull() {
            addCriterion("broken_count is null");
            return (Criteria) this;
        }

        public Criteria andBrokenCountIsNotNull() {
            addCriterion("broken_count is not null");
            return (Criteria) this;
        }

        public Criteria andBrokenCountEqualTo(Integer value) {
            addCriterion("broken_count =", value, "brokenCount");
            return (Criteria) this;
        }

        public Criteria andBrokenCountNotEqualTo(Integer value) {
            addCriterion("broken_count <>", value, "brokenCount");
            return (Criteria) this;
        }

        public Criteria andBrokenCountGreaterThan(Integer value) {
            addCriterion("broken_count >", value, "brokenCount");
            return (Criteria) this;
        }

        public Criteria andBrokenCountGreaterThanOrEqualTo(Integer value) {
            addCriterion("broken_count >=", value, "brokenCount");
            return (Criteria) this;
        }

        public Criteria andBrokenCountLessThan(Integer value) {
            addCriterion("broken_count <", value, "brokenCount");
            return (Criteria) this;
        }

        public Criteria andBrokenCountLessThanOrEqualTo(Integer value) {
            addCriterion("broken_count <=", value, "brokenCount");
            return (Criteria) this;
        }

        public Criteria andBrokenCountIn(List<Integer> values) {
            addCriterion("broken_count in", values, "brokenCount");
            return (Criteria) this;
        }

        public Criteria andBrokenCountNotIn(List<Integer> values) {
            addCriterion("broken_count not in", values, "brokenCount");
            return (Criteria) this;
        }

        public Criteria andBrokenCountBetween(Integer value1, Integer value2) {
            addCriterion("broken_count between", value1, value2, "brokenCount");
            return (Criteria) this;
        }

        public Criteria andBrokenCountNotBetween(Integer value1, Integer value2) {
            addCriterion("broken_count not between", value1, value2, "brokenCount");
            return (Criteria) this;
        }

        public Criteria andNumberIsNull() {
            addCriterion("number is null");
            return (Criteria) this;
        }

        public Criteria andNumberIsNotNull() {
            addCriterion("number is not null");
            return (Criteria) this;
        }

        public Criteria andNumberEqualTo(String value) {
            addCriterion("number =", value, "number");
            return (Criteria) this;
        }

        public Criteria andNumberNotEqualTo(String value) {
            addCriterion("number <>", value, "number");
            return (Criteria) this;
        }

        public Criteria andNumberGreaterThan(String value) {
            addCriterion("number >", value, "number");
            return (Criteria) this;
        }

        public Criteria andNumberGreaterThanOrEqualTo(String value) {
            addCriterion("number >=", value, "number");
            return (Criteria) this;
        }

        public Criteria andNumberLessThan(String value) {
            addCriterion("number <", value, "number");
            return (Criteria) this;
        }

        public Criteria andNumberLessThanOrEqualTo(String value) {
            addCriterion("number <=", value, "number");
            return (Criteria) this;
        }

        public Criteria andNumberLike(String value) {
            addCriterion("number like", value, "number");
            return (Criteria) this;
        }

        public Criteria andNumberNotLike(String value) {
            addCriterion("number not like", value, "number");
            return (Criteria) this;
        }

        public Criteria andNumberIn(List<String> values) {
            addCriterion("number in", values, "number");
            return (Criteria) this;
        }

        public Criteria andNumberNotIn(List<String> values) {
            addCriterion("number not in", values, "number");
            return (Criteria) this;
        }

        public Criteria andNumberBetween(String value1, String value2) {
            addCriterion("number between", value1, value2, "number");
            return (Criteria) this;
        }

        public Criteria andNumberNotBetween(String value1, String value2) {
            addCriterion("number not between", value1, value2, "number");
            return (Criteria) this;
        }

        public Criteria andBackCountIsNull() {
            addCriterion("back_count is null");
            return (Criteria) this;
        }

        public Criteria andBackCountIsNotNull() {
            addCriterion("back_count is not null");
            return (Criteria) this;
        }

        public Criteria andBackCountEqualTo(Integer value) {
            addCriterion("back_count =", value, "backCount");
            return (Criteria) this;
        }

        public Criteria andBackCountNotEqualTo(Integer value) {
            addCriterion("back_count <>", value, "backCount");
            return (Criteria) this;
        }

        public Criteria andBackCountGreaterThan(Integer value) {
            addCriterion("back_count >", value, "backCount");
            return (Criteria) this;
        }

        public Criteria andBackCountGreaterThanOrEqualTo(Integer value) {
            addCriterion("back_count >=", value, "backCount");
            return (Criteria) this;
        }

        public Criteria andBackCountLessThan(Integer value) {
            addCriterion("back_count <", value, "backCount");
            return (Criteria) this;
        }

        public Criteria andBackCountLessThanOrEqualTo(Integer value) {
            addCriterion("back_count <=", value, "backCount");
            return (Criteria) this;
        }

        public Criteria andBackCountIn(List<Integer> values) {
            addCriterion("back_count in", values, "backCount");
            return (Criteria) this;
        }

        public Criteria andBackCountNotIn(List<Integer> values) {
            addCriterion("back_count not in", values, "backCount");
            return (Criteria) this;
        }

        public Criteria andBackCountBetween(Integer value1, Integer value2) {
            addCriterion("back_count between", value1, value2, "backCount");
            return (Criteria) this;
        }

        public Criteria andBackCountNotBetween(Integer value1, Integer value2) {
            addCriterion("back_count not between", value1, value2, "backCount");
            return (Criteria) this;
        }
    }

    /**
     * storage_deviceback
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    /**
     * storage_deviceback 2018-03-22
     */
    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}