package com.chinaitop.depot.device.service;

import java.util.List;

import com.chinaitop.depot.device.model.BasicEquipmentEquipmentPool;
import com.chinaitop.depot.device.model.BasicEquipmentEquipmentPoolExample;

public interface BasicEquipmentEquipmentPoolService {

	/**
	 * 新增
	 * 
	 * @param record 数据对象
	 */
	void add(BasicEquipmentEquipmentPool record);

	/**
	 * 修改
	 * 
	 * @param record
	 *            数据对象
	 */
	void update(BasicEquipmentEquipmentPool record);

	/**
	 * 删除
	 * 
	 * @param id 数据ID
	 */
	void remove(Integer id);

	/**
	 * 查询一条数据
	 * 
	 * @param id 数据ID
	 * @return
	 */
	BasicEquipmentEquipmentPool findByIdObj(Integer id);

	/**
	 * 查询一组数据
	 * 
	 * @param example 查询条件
	 * @return
	 */
	List<BasicEquipmentEquipmentPool> findByCondition(BasicEquipmentEquipmentPoolExample example);

	/**
	 * 导入
	 * 
	 * @param list
	 * @param depotInfo
	 * @return
	 */
	String importData(List<List<String>> list, Integer orgId);
}
