package com.chinaitop.depot.device.service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.chinaitop.depot.device.model.ContentBean;
import com.chinaitop.depot.device.model.HouseNameBean;
import com.chinaitop.depot.device.model.HouseTypeBean;
import com.chinaitop.depot.device.model.ShelfContentBean;
import com.chinaitop.depot.device.model.StorageDeviceinput;
import com.chinaitop.depot.device.model.StorageDeviceinputExample;


public interface StorageDeviceInputService {

	
	List<StorageDeviceinput> queryByDevice(StorageDeviceinputExample storageDeviceinputExample);

	void remove(Integer id);

	void save(StorageDeviceinput storageDeviceinput);

	StorageDeviceinput loadDataById(int id);

	List<HouseNameBean> getHouseList();

	List<HouseTypeBean> getTypeList(Integer depotId);

	List<ShelfContentBean> getNameList(Integer depotTypeId,Integer orgId);

	ContentBean getcontentGetList(String deviceName);

	List<ContentBean> getShelfGetList(String deviceName);

	List<StorageDeviceinput> getDeviceInputList(Integer depotId);

	List<StorageDeviceinput> getModelList(String deviceName);

	List<StorageDeviceinput> getNumberList(String deviceModel);

	List<StorageDeviceinput> getCountList(String number);

	List<StorageDeviceinput> queryByNumber(StorageDeviceinputExample storageDeviceinputExample2);

	void updateByPrimaryKeySelective(StorageDeviceinput storageDeviceinput);

	List<StorageDeviceinput> getAllList(String number);

	List<ContentBean> getModelGetList(Map<String, Object> map);

	List<StorageDeviceinput> getNumberGetList(Map<String, Object> map);

	List<StorageDeviceinput> getUseCountGetList(String number);

	List<StorageDeviceinput> getDeviceModelList(String deviceName);

	StorageDeviceinput selectById(Integer number);

	List<StorageDeviceinput> getdevieName();

	List<StorageDeviceinput> getRepairNameList();

	List<StorageDeviceinput> getUseCount(Map<String, Object> map);

	List<StorageDeviceinput> queryDevice(HashMap<Object, Object> map);

	List<StorageDeviceinput> getDeviceModelRepair(String deviceName);

	List<StorageDeviceinput> getDeviceModelListRepair(String deviceName);

	List<Map<String, Object>> queryCountByType();

	List<StorageDeviceinput> queryDeviceAccount(StorageDeviceinputExample storageDeviceinputExample);



}
