package com.chinaitop.depot.device.mapper;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.ibatis.annotations.Param;

import com.chinaitop.depot.device.model.ContentBean;
import com.chinaitop.depot.device.model.HouseNameBean;
import com.chinaitop.depot.device.model.HouseTypeBean;
import com.chinaitop.depot.device.model.ShelfContentBean;
import com.chinaitop.depot.device.model.StorageDeviceinput;
import com.chinaitop.depot.device.model.StorageDeviceinputExample;

public interface StorageDeviceinputMapper {
    int countByExample(StorageDeviceinputExample example);

    int deleteByExample(StorageDeviceinputExample example);

    int deleteByPrimaryKey(Integer id);

    int insert(StorageDeviceinput record);

    int insertSelective(StorageDeviceinput record);

    List<StorageDeviceinput> selectByExample(StorageDeviceinputExample example);

    StorageDeviceinput selectByPrimaryKey(Integer id);

    int updateByExampleSelective(@Param("record") StorageDeviceinput record, @Param("example") StorageDeviceinputExample example);

    int updateByExample(@Param("record") StorageDeviceinput record, @Param("example") StorageDeviceinputExample example);

    int updateByPrimaryKeySelective(StorageDeviceinput record);

    int updateByPrimaryKey(StorageDeviceinput record);
    
    List<HouseNameBean> getHouseList();

   	List<HouseTypeBean> getTypeList(Integer depotId);
   	
   	List<ShelfContentBean> getShelfList(Integer depotTypeId);

   	List<ShelfContentBean> getNameList(Integer depotTypeId,Integer orgId);

   	ContentBean getcontentGetList(Map<String, Object> map);

   	List<StorageDeviceinput> getDeviceInputList(Integer depotId);

   	List<ContentBean> getShelfGetList(String deviceName);

   	List<StorageDeviceinput> getModelList(String deviceName);

   	List<StorageDeviceinput> getNumberList(String deviceModel);

   	List<StorageDeviceinput> getCountList(String number);

   	List<StorageDeviceinput> getAllList(String number);

   	List<ContentBean> getModelGetList(Map<String, Object> map);

   	List<StorageDeviceinput> getNumberGetList(Map<String, Object> map);

   	List<StorageDeviceinput> getUseCountGetList(String number);

   	List<StorageDeviceinput> getDeviceModelList(String deviceName);
   	
   	List<ContentBean> getcontentNameList(Integer depotTypeId);

   	List<StorageDeviceinput> getdevieName();

   	List<StorageDeviceinput> getRepairNameList();

   	List<StorageDeviceinput> getUseCount(Map<String, Object> map);

	List<StorageDeviceinput> queryDevice(HashMap<Object, Object> map);

	List<StorageDeviceinput> getDeviceModelRepair(String deviceName);

	List<StorageDeviceinput> getDeviceModelListRepair(String deviceName);

	List<Map<String, Object>> queryCountByType();

	List<StorageDeviceinput> queryDeviceAccount(StorageDeviceinputExample storageDeviceinputExample);
}