package com.chinaitop.depot.device.model;

import java.util.Date;

public class BasicEquipmentEquipmentPool {
    private Integer id;

    private Integer orgId;

    private String putPosition;

    private String shelfId;

    private String warehouseId;

    private String remark;

    private Integer inputPersonId;

    private Date inputDate;

    /**
     * 主键ID
     * @return id 主键ID
     */
    public Integer getId() {
        return id;
    }

    /**
     * 主键ID
     * @param id 主键ID
     */
    public void setId(Integer id) {
        this.id = id;
    }

    /**
     * 单位ID(粮库ID)
     * @return org_id 单位ID(粮库ID)
     */
    public Integer getOrgId() {
        return orgId;
    }

    /**
     * 单位ID(粮库ID)
     * @param orgId 单位ID(粮库ID)
     */
    public void setOrgId(Integer orgId) {
        this.orgId = orgId;
    }

    /**
     * 存放区域
     * @return put_position 存放区域
     */
    public String getPutPosition() {
        return putPosition;
    }

    /**
     * 存放区域
     * @param putPosition 存放区域
     */
    public void setPutPosition(String putPosition) {
        this.putPosition = putPosition == null ? null : putPosition.trim();
    }

    /**
     * 货架号
     * @return shelf_id 货架号
     */
    public String getShelfId() {
        return shelfId;
    }

    /**
     * 货架号
     * @param shelfId 货架号
     */
    public void setShelfId(String shelfId) {
        this.shelfId = shelfId == null ? null : shelfId.trim();
    }

    /**
     * 货位号
     * @return warehouse_id 货位号
     */
    public String getWarehouseId() {
        return warehouseId;
    }

    /**
     * 货位号
     * @param warehouseId 货位号
     */
    public void setWarehouseId(String warehouseId) {
        this.warehouseId = warehouseId == null ? null : warehouseId.trim();
    }

    /**
     * 备注
     * @return remark 备注
     */
    public String getRemark() {
        return remark;
    }

    /**
     * 备注
     * @param remark 备注
     */
    public void setRemark(String remark) {
        this.remark = remark == null ? null : remark.trim();
    }

    /**
     * 录入人
     * @return input_person_id 录入人
     */
    public Integer getInputPersonId() {
        return inputPersonId;
    }

    /**
     * 录入人
     * @param inputPersonId 录入人
     */
    public void setInputPersonId(Integer inputPersonId) {
        this.inputPersonId = inputPersonId;
    }

    /**
     * 录入时间
     * @return input_date 录入时间
     */
    public Date getInputDate() {
        return inputDate;
    }

    /**
     * 录入时间
     * @param inputDate 录入时间
     */
    public void setInputDate(Date inputDate) {
        this.inputDate = inputDate;
    }
}