package com.chinaitop.depot.device.model;

import java.util.Date;

public class StorageDevicekeep {
    private Integer id;

    private Integer orgId;

    private String deviceName;

    private String model;

    private Date keepStart;

    private Date keepEnd;

    private String keeper;

    private String deviceManager;

    private String number;

    private Integer keepStatus;

    private Integer inputId;
    
  //业务字段
    private String depotName;
    
    private String enumName;
    
    private String orgName;

    
    

    public String getOrgName() {
		return orgName;
	}

	public void setOrgName(String orgName) {
		this.orgName = orgName;
	}

	public String getEnumName() {
		return enumName;
	}

	public void setEnumName(String enumName) {
		this.enumName = enumName;
	}

	public String getDepotName() {
		return depotName;
	}

	public void setDepotName(String depotName) {
		this.depotName = depotName;
	}

    /**
     * 保养表
     * @return id 保养表
     */
    public Integer getId() {
        return id;
    }

    /**
     * 保养表
     * @param id 保养表
     */
    public void setId(Integer id) {
        this.id = id;
    }

    /**
     * 组织id
     * @return org_id 组织id
     */
    public Integer getOrgId() {
        return orgId;
    }

    /**
     * 组织id
     * @param orgId 组织id
     */
    public void setOrgId(Integer orgId) {
        this.orgId = orgId;
    }

    /**
     * 器材名称
     * @return device_name 器材名称
     */
    public String getDeviceName() {
        return deviceName;
    }

    /**
     * 器材名称
     * @param deviceName 器材名称
     */
    public void setDeviceName(String deviceName) {
        this.deviceName = deviceName == null ? null : deviceName.trim();
    }

    /**
     * 规格型号
     * @return model 规格型号
     */
    public String getModel() {
        return model;
    }

    /**
     * 规格型号
     * @param model 规格型号
     */
    public void setModel(String model) {
        this.model = model == null ? null : model.trim();
    }

    /**
     * 保养开始时间
     * @return keep_start 保养开始时间
     */
    public Date getKeepStart() {
        return keepStart;
    }

    /**
     * 保养开始时间
     * @param keepStart 保养开始时间
     */
    public void setKeepStart(Date keepStart) {
        this.keepStart = keepStart;
    }

    /**
     * 保养结束时间
     * @return keep_end 保养结束时间
     */
    public Date getKeepEnd() {
        return keepEnd;
    }

    /**
     * 保养结束时间
     * @param keepEnd 保养结束时间
     */
    public void setKeepEnd(Date keepEnd) {
        this.keepEnd = keepEnd;
    }

    /**
     * 保养负责人
     * @return keeper 保养负责人
     */
    public String getKeeper() {
        return keeper;
    }

    /**
     * 保养负责人
     * @param keeper 保养负责人
     */
    public void setKeeper(String keeper) {
        this.keeper = keeper == null ? null : keeper.trim();
    }

    /**
     * 设备管理员
     * @return device_manager 设备管理员
     */
    public String getDeviceManager() {
        return deviceManager;
    }

    /**
     * 设备管理员
     * @param deviceManager 设备管理员
     */
    public void setDeviceManager(String deviceManager) {
        this.deviceManager = deviceManager == null ? null : deviceManager.trim();
    }

    /**
     * 设备编号
     * @return number 设备编号
     */
    public String getNumber() {
        return number;
    }

    /**
     * 设备编号
     * @param number 设备编号
     */
    public void setNumber(String number) {
        this.number = number == null ? null : number.trim();
    }

    /**
     * 保养状态（0：正常 ，1：保养中）
     * @return keep_status 保养状态（0：正常 ，1：保养中）
     */
    public Integer getKeepStatus() {
        return keepStatus;
    }

    /**
     * 保养状态（0：正常 ，1：保养中）
     * @param keepStatus 保养状态（0：正常 ，1：保养中）
     */
    public void setKeepStatus(Integer keepStatus) {
        this.keepStatus = keepStatus;
    }

    /**
     * 关联入库表
     * @return input_id 关联入库表
     */
    public Integer getInputId() {
        return inputId;
    }

    /**
     * 关联入库表
     * @param inputId 关联入库表
     */
    public void setInputId(Integer inputId) {
        this.inputId = inputId;
    }
}