package com.chinaitop.depot.device.service;

import com.chinaitop.depot.device.model.StorageDevicecheck;
import com.chinaitop.depot.device.model.StorageDevicecheckExample;
import com.chinaitop.depot.device.model.StorageDeviceinput;
import com.chinaitop.depot.device.model.StorageDeviceinputExample;

import java.util.List;
import java.util.Map;

public interface StorageDeviceCheckService {


	/**
	 * 分页查询盘点单
	 * @param storageDevicecheckExample
	 * @return
	 */
	List<StorageDevicecheck> queryByExample(StorageDevicecheckExample storageDevicecheckExample);

	/**
	 * 按照主键移除
	 * @param depotId
	 */
	void remove(Integer depotId,String checkNum);

    /**
     * 新增
     * @param json
     */
	void add(String json,String type);

	/**
	 * 根据depotId查询对应数据
	 * @param depotId
	 * @return
	 */
	List<StorageDevicecheck> loadDataByDepotId(Integer depotId,String pddh);


	List<StorageDeviceinput> childZlList(StorageDeviceinputExample storageDeviceinputExample);

    /**
     * 获取当天的总盘点记录数
     * @return
     */
	int getCountForDate(Map<String,Object> map);
}
